//  PROGRAMME SCONVERT
//  Version 4.1.4 20051014
//  Copyright Jacques-Deric Rouault
//  Designed for Scilab 3.1.1

mprintf ("\nPROGRAMME SCONVERT : CONVERSION DES FICHIERS DESCRIPTEURS EN FICHIERS DATA\n");
mprintf ("PROGRAM SCONVERT : CONVERTING DESCRIPTOR FILES INTO DATA FILES\n");
racine_prog = "SCONVERT";

// ETAPE/STEP 01 : REPERTOIRE DE TRAVAIL / WORKING DIRECTORY
[fsci,erreur] = mopen (racine_prog + ".SCI","r");
repertoire_prog = getcwd ();
if erreur<>0 then
  repertoire_prog=tk_getdir(title="REPERTOIRE DE L''APPLICATION\nAPPLICATION DIRECTORY");
  chdir (repertoire_prog);
  [fsci,erreur] = mopen (racine_prog + ".SCI","r");
  if erreur<>0 then 
    mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine_prog + ".SCI\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine_prog + ".SCI\n\n");
    abort; 
  end;  
end;
mclose (fsci);

// ETAPE/STEP 02 : CREATION DU FICHIER MOUCHARD / CREATING THE SNEAK FILE
[fmch,erreur] = mopen ("SOLIDES.MCH","w");
mfprintf (fmch,"ETAPE/STEP 01-02\n");
mfprintf (fmch,"PROGRAMME SCONVERT : CONVERSION DES FICHIERS DESCRIPTEURS EN FICHIERS DATA\n");
mfprintf (fmch,"PROGRAM SCONVERT : CONVERTING DESCRIPTOR FILES INTO DATA FILES\n");
mfprintf (fmch,"Version 4.1.3 20051013\n");
mfprintf (fmch,"Copyright Jacques-Deric Rouault\n");

// ETAPE/STEP 03 : OUVERTURE DU FICHIER SOLIDES.TXT / OPENING THE FILE SOLIDES.TXT
mfprintf (fmch,"\nETAPE/STEP 03 : OUVERTURE DU FICHIER / OPENING THE FILE SOLIDES.TXT\n");
mprintf ("Lecture du fichier / Reading the file SOLIDES.TXT\n");
[fs,err] = mopen ("SOLIDES.TXT","r");
if err<>0 then
  mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER SOLIDES.TXT\n");
  mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE SOLIDES.TXT\n");
  mfprintf (fmch,"\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER SOLIDES.TXT\n");
  mfprintf (fmch,"THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE SOLIDES.TXT\n");
  mclose (fmch);
  abort; 
end;
mfprintf (fmch,"Fichier SOLIDES.TXT ouvert / File SOLIDES.TXT is open\n");
str = mgetl (fs,1);
if str == "SOLIDS-V4" then 
  mfprintf (fmch,"Entete SOLIDS-V4 reconnue / Header SOLIDS-V4 is identified\n");
else
  mfprintf (fmch,"ENTETE SOLIDE-V4 NON RECONNUE / HEADER SOLIDS-V4 NOT RECOGNIZED\n");
  mfprintf (fmch,str + "\n");
  mclose (fs);  
  mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
  mclose (fmch);  
  mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
  mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
  abort;
end;              
str = mgetl (fs,1);
mfprintf (fmch,"Commentaire / Comment = %s\n",str);

// ETAPE/STEP 04 : LECTURE DES RACINES / READING ROOTS
mfprintf (fmch,"\nETAPE/STEP 04 : LECTURE DES RACINES / READING ROOTS\n");
str = mgetl (fs,1);
nracines = sscanf (str,"%i");
mfprintf (fmch,"Nombre de fichiers racine / Number of root files = %i\n",nracines);
for nr=1:nracines do
  str = mgetl (fs,1);
  [rang,rep,racine] = sscanf (str,"%i %i %s");
  mfprintf (fmch,"\n\nETAPE/STEP 04 : Rang/Rank = %i -- Rang = %i -- Representation = %i\n", nr, rang, rep);
  select rep
    case 0 then mfprintf (fmch,"Solide non reprsent / Solid not represented\n");
    case 1 then mfprintf (fmch,"Solide reprsent en segments / Solid represented as segments\n");
    case 2 then mfprintf (fmch,"Solide reprsent en faces / Solid represented as faces\n");
    else
      mfprintf (fmch,"VALEUR NON CONFORME / UNCORRECT VALUE\n");
      mclose (fs);  
      mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
      mclose (fmch);  
      mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
      mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
      abort;     
  end;
  mprintf ("\nAnalyse du fichier / Analyzing the file " + racine + ".TXT\n");
  mfprintf (fmch,"Analyse du fichier / Analyzing the file " + racine + ".TXT\n");
  
  // ETAPE/STEP 05 : OUVERTURE DU FICHIER RACINE / OPENING THE ROOT FILE
  mfprintf (fmch,"\nETAPE/STEP 05 : OUVERTURE DU FICHIER RACINE "+ racine + ".TXT\n");
  [fr,err] = mopen (racine + ".TXT","r");
  if err<>0 then
    mprintf ("LE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine + ".TXT\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine + ".TXT\n");
    mfprintf (fmch,"\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine + ".TXT\n");
    mfprintf (fmch,"THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine + ".TXT\n");
    mclose (fs);
    mclose (fmch);
    abort; 
  end;
  mfprintf (fmch,"Fichier " + racine + ".TXT ouvert / File " + racine + ".TXT is open\n");
  str = mgetl (fr,1);
  if str == "SOLIDE-V4" then 
    mfprintf (fmch,"Entete SOLIDE-V4 reconnue / Header SOLIDE-V4 is identified\n");
  else
    mfprintf (fmch,"ENTETE SOLIDE-V4 NON RECONNUE / HEADER SOLIDE-V4 IS NOT RECOGNIZED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fmch,str + "\n");

  // ETAPE/STEP 06 : LECTURE DE LA SECTION POINTS / READING THE SECTION POINTS
  mfprintf (fmch,"\nETAPE/STEP 06 : LECTURE DE LA SECTION POINTS / READING THE SECTION POINTS\n");
  str = mgetl (fr,1);
  if str == "POINTS" then 
    mfprintf (fmch,"Section POINTS reconnue / Section POINTS identified\n");
  else
    mfprintf (fmch,"SECTION POINTS NON RECONNUE / SECTION POINTS NOT IDENTIFIED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  str = mgetl (fr,1);
  npoints = sscanf (str,"%i");
  mfprintf (fmch,"Nombre de points / Number of points = %i\n",npoints);
  tpoints = [];
  for np=1:npoints do
    str = mgetl (fr,1);
    mfprintf (fmch,str);
    [rang,x,y,z] = sscanf (str,"%i %f %f %f");
    mfprintf (fmch,"\nr = %i -  rang/rank = %i -  x = %f -  y = %f -  z = %f\n",np,rang,x,y,z);
    tpoints (np,1) = x;
    tpoints (np,2) = y;
    tpoints (np,3) = z;
  end;
   
  // ETAPE/STEP 07 : LECTURE DE LA SECTION SEGMENTS / READING THE SECTION SEGMENTS
  mfprintf (fmch,"\nETAPE/STEP 07 : LECTURE DE LA SECTION SEGMENTS / READING THE SECTION SEGMENTS\n");
  str = mgetl (fr,1);
  if str == "SEGMENTS" then 
    mfprintf (fmch,"Section SEGMENTS reconnue / Section segment is identified\n");
  else
    mfprintf (fmch,"SECTION SEGMENTS NON RECONNUE / SECTION SEGMENTS NOT IDENTIFIED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  str = mgetl (fr,1);
  epaisseur = sscanf (str,"%i");
  mfprintf (fmch,"Epaisseur des segments / Thickness of segments = %i\n",epaisseur);
  str = mgetl (fr,1);
  nsegments = sscanf (str,"%i");
  mfprintf (fmch,"Nombre de segments / Number of segments = %i\n",nsegments);
  tsegments = [];
  for ns=1:nsegments do
    str = mgetl (fr,1);
    mfprintf (fmch,str);
    [rang,p1,p2,c] = sscanf (str,"%i %i %i %i");
    mfprintf (fmch,"\ns = %i -  rang = %i -  p1 = %i -  p2 = %i -  c = %i\n",ns,rang,p1,p2,c);
    if (p1<1) or (p1>npoints) or (p2<1) or (p2>npoints) then
      mfprintf (fmch,"RANG DE POINT NON CONFORME / RANK OF POINT OUT OF RANGE\n");
      mclose (fr);  
      mclose (fs);  
      mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
      mclose (fmch);  
      mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
      mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
      abort;
    end;
    tsegments (ns,1) = p1;
    tsegments (ns,2) = p2;
    tsegments (ns,3) = c;
  end;
   
  // ETAPE/STEP 08 : LECTURE DE LA SECTION FACES / READING THE SECTION FACES
  mfprintf (fmch,"\nETAPE/STEP 08 : LECTURE DE LA SECTION FACES / READING THE SECTION FACES\n");
  str = mgetl (fr,1);
  if str == "FACES" then 
    mfprintf (fmch,"Section FACES reconnue / Section FACES is identified\n");
  else
    mfprintf (fmch,"SECTION FACES NON RECONNUE / SECTION FACES NOT IDENTIFIED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  str = mgetl (fr,1);
  nfaces = sscanf (str,"%i");
  mfprintf (fmch,"Nombre de faces / Number of faces = %i\n",nfaces);
  tfaces = [];
  tcotes = [];
   
  for nf=1:nfaces do
    str = mgetl (fr,1);
    mfprintf (fmch,str);
    [rang,ncotes] = sscanf (str,"%i %i");
    mfprintf (fmch,"\nf = %i -  rang/rank = %i \n",nf,rang);
    mfprintf (fmch,"Nombre de cotes / Number of edges = %i\n",ncotes);
 
    if (ncotes<3) or (ncotes>8) then
      mfprintf (fmch,"VALEUR NON CONFORME / VALUE OUT OF RANGE\n");
      mclose (fr);
      mclose (fs);
      mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
      mclose (fmch);
      mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
      mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
      abort;
   end;
    
    tcotes (nf) = ncotes;
    select ncotes
      case 3 then 
        [rang,n,p1,p2,p3,c] = sscanf (str,"%i %i %i %i %i %i");
        mfprintf (fmch,"\np1 = %i -  p2 = %i -  p3 = %i -  c = %i\n",p1,p2,p3,c);
        if (p1<1) or (p1>npoints) or (p2<1) or (p2>npoints) or (p3<1) or (p3>npoints) then
          mfprintf (fmch,"RANG DE POINT NON CONFORME\n");
          mclose (fr);  
          mclose (fs);  
          mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
          mclose (fmch);  
          mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
          mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
          abort;
        end;
        tfaces (nf,1) = p1;
        tfaces (nf,2) = p2;
        tfaces (nf,3) = p3;
        tfaces (nf,4) = c;     
      case 4 then 
        [rang,n,p1,p2,p3,p4,c] = sscanf (str,"%i %i %i %i %i %i %i");
        mfprintf (fmch,"\np1 = %i -  p2 = %i -  p3 = %i -  p4 = %i -  c = %i\n",p1,p2,p3,p4,c);
        if (p1<1) or (p1>npoints) or (p2<1) or (p2>npoints) or (p3<1) or (p3>npoints) or (p4<1) or (p4>npoints) then
          mfprintf (fmch,"RANG DE POINT NON CONFORME\n");
          mclose (fr);  
          mclose (fs);  
          mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
          mclose (fmch);  
          mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
          mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
          abort;
        end;
        tfaces (nf,1) = p1;
        tfaces (nf,2) = p2;
        tfaces (nf,3) = p3;
        tfaces (nf,4) = p4;
        tfaces (nf,5) = c;
      case 5 then 
        [rang,n,p1,p2,p3,p4,p5,c] = sscanf (str,"%i %i %i %i %i %i %i %i");
        mfprintf (fmch,"\np1 = %i -  p2 = %i -  p3 = %i -  p4 = %i -  p5 = %i -  c = %i\n",p1,p2,p3,p4,p5,c);
        if (p1<1) or (p1>npoints) or (p2<1) or (p2>npoints) or (p3<1) or (p3>npoints) or (p4<1) or (p4>npoints) or (p5<1) or (p5>npoints) then
          mfprintf (fmch,"RANG DE POINT NON CONFORME\n");
          mclose (fr);  
          mclose (fs);  
          mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
          mclose (fmch);  
          mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
          mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
          abort;
        end;
        tfaces (nf,1) = p1;
        tfaces (nf,2) = p2;
        tfaces (nf,3) = p3;
        tfaces (nf,4) = p4;
        tfaces (nf,5) = p5;
        tfaces (nf,6) = c;
      case 6 then 
        [rang,n,p1,p2,p3,p4,p5,p6,c] = sscanf (str,"%i %i %i %i %i %i %i %i %i");
        mfprintf (fmch,"\np1 = %i -  p2 = %i -  p3 = %i -  p4 = %i -  p5 = %i -  p6 = %i -  c = %i\n",p1,p2,p3,p4,p5,p6,c);
        if (p1<1) or (p1>np) or (p2<1) or (p2>npoints) or (p3<1) or (p3>npoints) or (p4<1) or (p4>npoints) or (p5<1) or (p5>npoints) or (p6<1) or (p6>npoints) then
          mfprintf (fmch,"RANG DE POINT NON CONFORME\n");
          mclose (fr);  
          mclose (fs);  
          mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
          mclose (fmch);  
          mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
          mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
          abort;
        end;
        tfaces (nf,1) = p1;
        tfaces (nf,2) = p2;
        tfaces (nf,3) = p3;
        tfaces (nf,4) = p4;
        tfaces (nf,5) = p5;
        tfaces (nf,6) = p6;
        tfaces (nf,7) = c;
       case 7 then 
        [rang,n,p1,p2,p3,p4,p5,p6,p7,c] = sscanf (str,"%i %i %i %i %i %i %i %i %i %i");
        mfprintf (fmch,"\np1 = %i -  p2 = %i -  p3 = %i -  p4 = %i -  p5 = %i -  p6 = %i -  p7 = %i -  c = %i\n",p1,p2,p3,p4,p5,p6,p7,c);
        if (p1<1) or (p1>npoints) or (p2<1) or (p2>npoints) or (p3<1) or (p3>npoints) or (p4<1) or (p4>npoints) or (p5<1) or (p5>npoints) or (p6<1) or (p6>npoints) or (p7<1) or (p7>npoints) then
          mfprintf (fmch,"RANG DE POINT NON CONFORME\n");
          mclose (fr);  
          mclose (fs);  
          mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
          mclose (fmch);  
          mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
          mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
          abort;
        end;
        tfaces (nf,1) = p1;
        tfaces (nf,2) = p2;
        tfaces (nf,3) = p3;
        tfaces (nf,4) = p4;
        tfaces (nf,5) = p5;
        tfaces (nf,6) = p6;
        tfaces (nf,7) = p7;
        tfaces (nf,8) = c;
       case 8 then 
        [rang,n,p1,p2,p3,p4,p5,p6,p7,p8,c] = sscanf (str,"%i %i %i %i %i %i %i %i %i %i %i");
        mfprintf (fmch,"\np1 = %i -  p2 = %i -  p3 = %i -  p4 = %i -  p5 = %i -  p6 = %i -  p7 = %i -  p8 = %i -  c = %i\n",p1,p2,p3,p4,p5,p6,p7,p8,c);
        if (p1<1) or (p1>npoints) or (p2<1) or (p2>npoints) or (p3<1) or (p3>npoints) or (p4<1) or (p4>npoints) or (p5<1) or (p5>npoints) or (p6<1) or (p6>npoints) or (p7<1) or (p7>npoints) or (p8<1) or (p8>npoints) then
          mfprintf (fmch,"RANG DE POINT NON CONFORME\n");
          mclose (fr);  
          mclose (fs);  
          mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
          mclose (fmch);  
          mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
          mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
          abort;
        end;
        tfaces (nf,1) = p1;
        tfaces (nf,2) = p2;
        tfaces (nf,3) = p3;
        tfaces (nf,4) = p4;
        tfaces (nf,5) = p5;
        tfaces (nf,6) = p6;
        tfaces (nf,7) = p7;
        tfaces (nf,8) = p8;
        tfaces (nf,9) = c;
   end;
  end;
   
  // ETAPE/STEP 09 : LECTURE DE LA SECTION TRANSFORMATIONS / READING THE SECTION TRANSFORMATION
  mfprintf (fmch,"\nETAPE/STEP 09 : LECTURE DE LA SECTION TRANSFORMATIONS / READING THE SECTION TRANSFORMATION\n");
  str = mgetl (fr,1);
  if str == "TRANSFS" then 
    mfprintf (fmch,"Section TRANSFS reconnue / Section TRANSFS is identified\n");
  else
    mfprintf (fmch,"SECTION TRANSFS NON RECONNUE / SECTION TRANFS NOT IDENTIFIED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  homox = sscanf (str,"%f");
  mfprintf (fmch,"\ntransx = %f\n",homox);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  homoy = sscanf (str,"%f");
  mfprintf (fmch,"\ntransy = %f\n",homoy);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  homoz = sscanf (str,"%f");
  mfprintf (fmch,"\ntransz = %f\n",homoz);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  azimut = sscanf (str,"%f");
  mfprintf (fmch,"\nazimut = %f\n",azimut);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  tangue = sscanf (str,"%f");
  mfprintf (fmch,"\ntangue  = %f\n",tangue);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  roule = sscanf (str,"%f");
  mfprintf (fmch,"\nroule = %f\n",roule);
  
  // ETAPE/STEP 10 : LECTURE DE LA SECTION IMPLEMENTATION / READING THE SECTION IMPLEMENTATION
  mfprintf (fmch,"\nETAPE/STEP 10 : LECTURE DE LA SECTION IMPLEMENTATION / READING THE SECTION IMPLEMENTATION\n");
  str = mgetl (fr,1);
  if str == "IMPLEM" then 
    mfprintf (fmch,"Section IMPLEM reconnue / Section IMPLEM is identified\n");
  else
    mfprintf (fmch,"SECTION IMPLEM NON RECONNUE / SECTION IMPLEM NOT IDENTIFIED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  transx = sscanf (str,"%f");
  mfprintf (fmch,"\ntransx = %f\n",transx);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  transy = sscanf (str,"%f");
  mfprintf (fmch,"\ntransy = %f\n",transy);
  str = mgetl (fr,1);
  mfprintf (fmch,str);
  transz = sscanf (str,"%f");
  mfprintf (fmch,"\ntransz = %f\n",transz);

  // ETAPE/STEP 11 : LECTURE DE LA SECTION FINEND / READING THE SECTION FINEND
  mfprintf (fmch,"\nETAPE/STEP 11 : LECTURE DE LA SECTION FINEND / READING THE SECTION FINEND\n");
  str = mgetl (fr,1);
  if str == "FINEND" then 
    mfprintf (fmch,"Section FINEND reconnue / Section FINEND identified\n");
    mprintf ("Fichier " + racine + ".TXT correctement analys\n");
    mprintf ("File " + racine + ".TXT correctely analysed\n");
    mclose (fr);
  else
    mfprintf (fmch,"SECTION FINEND NON RECONNUE / SECTION FINEND NOT IDENTIFIED\n");
    mfprintf (fmch,str + "\n");
    mclose (fr);  
    mclose (fs);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;
  
  // ETAPE/STEP 12 : HOMOTHETIES / HOMOTHECIES
  mfprintf (fmch,"\nETAPE/STEP 12 : HOMOTHETIES / HOMOTHECIES\n");
  tpoints (:,1) = tpoints (:,1) * homox;
  tpoints (:,2) = tpoints (:,2) * homoy;
  tpoints (:,3) = tpoints (:,3) * homoz;
  for np=1:npoints do
    mfprintf (fmch,"%i   %f  %f  %f\n",np,tpoints (np,1),tpoints (np,2),tpoints (np,3));
  end;
  
  // ETAPE/STEP 13 : ROTATIONS / ROTATIONS
  mfprintf (fmch,"\nETAPE/STEP 13 : ROTATIONS / ROTATIONS\n");
  tpoints2 = [];
  angle = azimut/360.0*(2.0*%pi);
  cosangle = cos (angle);
  sinangle = sin (angle);
  tpoints2 (:,1) = cosangle*tpoints(:,1)+sinangle*tpoints(:,2);
  tpoints2 (:,2) =-sinangle*tpoints(:,1)+cosangle*tpoints(:,2);
  tpoints2 (:,3) = tpoints (:,3);
  for np=1:npoints do
    mfprintf (fmch,"%i   %f  %f  %f\n",np,tpoints2 (np,1),tpoints2 (np,2),tpoints2 (np,3));
  end;

  angle = tangue/360.0*(2.0*%pi);
  cosangle = cos (angle);
  sinangle = sin (angle);
  tpoints (:,1) = cosangle*tpoints2(:,1)+sinangle*tpoints2(:,3);
  tpoints (:,3) =-sinangle*tpoints2(:,1)+cosangle*tpoints2(:,3);
  tpoints (:,2) = tpoints2 (:,2);
  for np=1:npoints do
    mfprintf (fmch,"%i   %f  %f  %f\n",np,tpoints2 (np,1),tpoints2 (np,2),tpoints2 (np,3));
  end;

  angle = roule/360.0*(2.0*%pi);
  cosangle = cos (angle);
  sinangle = sin (angle);
  tpoints2 (:,2) = cosangle*tpoints(:,2)+sinangle*tpoints(:,3);
  tpoints2 (:,3) =-sinangle*tpoints(:,2)+cosangle*tpoints(:,3);
  tpoints2 (:,1) = tpoints (:,1);
  for np=1:npoints do
    mfprintf (fmch,"%i   %f  %f  %f\n",np,tpoints2 (np,1),tpoints2 (np,2),tpoints2 (np,3));
  end;

  // ETAPE/STEP 14 : TRANSLATION / TRANSLATION
  mfprintf (fmch,"\nETAPE/STEP 14 : TRANSLATION\n");
  tpoints (:,1) = tpoints2 (:,1) + transx;
  tpoints (:,2) = tpoints2 (:,2) + transy;
  tpoints (:,3) = tpoints2 (:,3) + transz;
  for np=1:npoints do
    mfprintf (fmch,"%i   %f  %f  %f\n",np,tpoints (np,1),tpoints (np,2),tpoints (np,3));
  end;
  
  // ETAPE/STEP 15 : CREATION DU TABLEAU SEGS
  mfprintf (fmch,"\nETAPE/STEP 15 : CREATION DU TABLEAU SEGS\n");
//  nsegs = 2*nsegments+2;
  nsegs = 2*nsegments;
  ts = [];
  tcs = [];
  // pour neutralise bug sur premier segment
//  ts($+1,1) = tpoints (tsegments(1,1),1);
//  ts($,2)   = tpoints (tsegments(1,1),2);
//  ts($,3)   = tpoints (tsegments(1,1),3);
//  ts($+1,1) = tpoints (tsegments(1,1),1);
//  ts($,2)   = tpoints (tsegments(1,1),2);
//  ts($,3)   = tpoints (tsegments(1,1),3);
//  tcs($+1)  = 101;  

  for ns=1:nsegments do
    ts($+1,1) = tpoints (tsegments(ns,1),1);
    ts($,2)   = tpoints (tsegments(ns,1),2);
    ts($,3)   = tpoints (tsegments(ns,1),3);
    ts($+1,1) = tpoints (tsegments(ns,2),1);
    ts($,2)   = tpoints (tsegments(ns,2),2);
    ts($,3)   = tpoints (tsegments(ns,2),3);
    tcs($+1)  = tsegments(ns,3);  
  end;

  // ETAPE/STEP 16 : CREATION DES TABLEAUX PX PY PZ / CREATING TABLES PX, PY, PZ
  mfprintf (fmch,"\nETAPE/STEP 16 : CREATION DES TABLEAUX PX PY PZ / CREATING TABLES PX, PY, PZ\n");
  px = [];
  py = [];
  pz = [];
  
  pcf = [];
  nfacess = 0;
  
  for nf=1:nfaces do
    select tcotes(nf)
      case 3 then 
        // Points des milieux des segments
        tpoints (npoints+1,:) = (tpoints(tfaces(nf,3),:) + tpoints(tfaces(nf,1),:))/2.0;
        tpoints (npoints+2,:) = (tpoints(tfaces(nf,1),:) + tpoints(tfaces(nf,2),:))/2.0;
        tpoints (npoints+3,:) = (tpoints(tfaces(nf,2),:) + tpoints(tfaces(nf,3),:))/2.0;

        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,2),1);
        px(3,$)   = tpoints (npoints+3,1);  
        px(4,$)   = tpoints (npoints+1,1);  
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,2),2);
        py(3,$)   = tpoints (npoints+3,2);  
        py(4,$)   = tpoints (npoints+1,2);  
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,2),3);
        pz(3,$)   = tpoints (npoints+3,3);  
        pz(4,$)   = tpoints (npoints+1,3); 
        pcf($+1)  = tfaces(nf,4);      
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,2),1);
        px(2,$)   = tpoints (tfaces(nf,3),1);
        px(3,$)   = tpoints (npoints+1,1);  
        px(4,$)   = tpoints (npoints+2,1);  
        py(1,$+1) = tpoints (tfaces(nf,2),2);
        py(2,$)   = tpoints (tfaces(nf,3),2);
        py(3,$)   = tpoints (npoints+1,2);  
        py(4,$)   = tpoints (npoints+2,2);  
        pz(1,$+1) = tpoints (tfaces(nf,2),3);
        pz(2,$)   = tpoints (tfaces(nf,3),3);
        pz(3,$)   = tpoints (npoints+1,3);  
        pz(4,$)   = tpoints (npoints+2,3); 
        pcf($+1)  = tfaces(nf,4);      
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,3),1);
        px(2,$)   = tpoints (tfaces(nf,1),1);
        px(3,$)   = tpoints (npoints+2,1);  
        px(4,$)   = tpoints (npoints+3,1);  
        py(1,$+1) = tpoints (tfaces(nf,3),2);
        py(2,$)   = tpoints (tfaces(nf,1),2);
        py(3,$)   = tpoints (npoints+2,2);  
        py(4,$)   = tpoints (npoints+3,2);  
        pz(1,$+1) = tpoints (tfaces(nf,3),3);
        pz(2,$)   = tpoints (tfaces(nf,1),3);
        pz(3,$)   = tpoints (npoints+2,3);  
        pz(4,$)   = tpoints (npoints+3,3); 
        pcf($+1) = tfaces(nf,4);      
        nfacess=nfacess+1;
        
        npoints = npoints+3;
      case 4 then 
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,2),1);
        px(3,$)   = tpoints (tfaces(nf,3),1);
        px(4,$)   = tpoints (tfaces(nf,4),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,2),2);
        py(3,$)   = tpoints (tfaces(nf,3),2);
        py(4,$)   = tpoints (tfaces(nf,4),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,2),3);
        pz(3,$)   = tpoints (tfaces(nf,3),3);
        pz(4,$)   = tpoints (tfaces(nf,4),3);
        pcf($+1)  = tfaces(nf,5);  
        nfacess=nfacess+1;
      case 5 then 
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,2),1);
        px(3,$)   = tpoints (tfaces(nf,3),1);
        px(4,$)   = tpoints (tfaces(nf,4),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,2),2);
        py(3,$)   = tpoints (tfaces(nf,3),2);
        py(4,$)   = tpoints (tfaces(nf,4),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,2),3);
        pz(3,$)   = tpoints (tfaces(nf,3),3);
        pz(4,$)   = tpoints (tfaces(nf,4),3);
        pcf($+1)  = tfaces(nf,6);  
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,3),1);
        px(3,$)   = tpoints (tfaces(nf,4),1);
        px(4,$)   = tpoints (tfaces(nf,5),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,3),2);
        py(3,$)   = tpoints (tfaces(nf,4),2);
        py(4,$)   = tpoints (tfaces(nf,5),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,3),3);
        pz(3,$)   = tpoints (tfaces(nf,4),3);
        pz(4,$)   = tpoints (tfaces(nf,5),3);
        pcf($+1)  = tfaces(nf,6);  
        nfacess=nfacess+1;
      case 6 then 
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,2),1);
        px(3,$)   = tpoints (tfaces(nf,3),1);
        px(4,$)   = tpoints (tfaces(nf,4),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,2),2);
        py(3,$)   = tpoints (tfaces(nf,3),2);
        py(4,$)   = tpoints (tfaces(nf,4),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,2),3);
        pz(3,$)   = tpoints (tfaces(nf,3),3);
        pz(4,$)   = tpoints (tfaces(nf,4),3);
        pcf($+1)  = tfaces(nf,7);  
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,4),1);
        px(3,$)   = tpoints (tfaces(nf,5),1);
        px(4,$)   = tpoints (tfaces(nf,6),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,4),2);
        py(3,$)   = tpoints (tfaces(nf,5),2);
        py(4,$)   = tpoints (tfaces(nf,6),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,4),3);
        pz(3,$)   = tpoints (tfaces(nf,5),3);
        pz(4,$)   = tpoints (tfaces(nf,6),3);
        pcf($+1)  = tfaces(nf,7);  
        nfacess=nfacess+1;
      case 7 then 
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,2),1);
        px(3,$)   = tpoints (tfaces(nf,3),1);
        px(4,$)   = tpoints (tfaces(nf,4),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,2),2);
        py(3,$)   = tpoints (tfaces(nf,3),2);
        py(4,$)   = tpoints (tfaces(nf,4),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,2),3);
        pz(3,$)   = tpoints (tfaces(nf,3),3);
        pz(4,$)   = tpoints (tfaces(nf,4),3);
        pcf($+1)  = tfaces(nf,8);  
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,4),1);
        px(3,$)   = tpoints (tfaces(nf,5),1);
        px(4,$)   = tpoints (tfaces(nf,6),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,4),2);
        py(3,$)   = tpoints (tfaces(nf,5),2);
        py(4,$)   = tpoints (tfaces(nf,6),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,4),3);
        pz(3,$)   = tpoints (tfaces(nf,5),3);
        pz(4,$)   = tpoints (tfaces(nf,6),3);
        pcf($+1)  = tfaces(nf,8);  
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,5),1);
        px(3,$)   = tpoints (tfaces(nf,6),1);
        px(4,$)   = tpoints (tfaces(nf,7),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,5),2);
        py(3,$)   = tpoints (tfaces(nf,6),2);
        py(4,$)   = tpoints (tfaces(nf,7),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,5),3);
        pz(3,$)   = tpoints (tfaces(nf,6),3);
        pz(4,$)   = tpoints (tfaces(nf,7),3);
        pcf($+1)  = tfaces(nf,8);  
        nfacess=nfacess+1;
      case 8 then 
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,2),1);
        px(3,$)   = tpoints (tfaces(nf,3),1);
        px(4,$)   = tpoints (tfaces(nf,4),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,2),2);
        py(3,$)   = tpoints (tfaces(nf,3),2);
        py(4,$)   = tpoints (tfaces(nf,4),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,2),3);
        pz(3,$)   = tpoints (tfaces(nf,3),3);
        pz(4,$)   = tpoints (tfaces(nf,4),3);
        pcf($+1)  = tfaces(nf,9);  
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,4),1);
        px(3,$)   = tpoints (tfaces(nf,5),1);
        px(4,$)   = tpoints (tfaces(nf,6),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,4),2);
        py(3,$)   = tpoints (tfaces(nf,5),2);
        py(4,$)   = tpoints (tfaces(nf,6),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,4),3);
        pz(3,$)   = tpoints (tfaces(nf,5),3);
        pz(4,$)   = tpoints (tfaces(nf,6),3);
        pcf($+1)  = tfaces(nf,9);  
        nfacess=nfacess+1;
        
        px(1,$+1) = tpoints (tfaces(nf,1),1);
        px(2,$)   = tpoints (tfaces(nf,6),1);
        px(3,$)   = tpoints (tfaces(nf,7),1);
        px(4,$)   = tpoints (tfaces(nf,8),1);
        py(1,$+1) = tpoints (tfaces(nf,1),2);
        py(2,$)   = tpoints (tfaces(nf,6),2);
        py(3,$)   = tpoints (tfaces(nf,7),2);
        py(4,$)   = tpoints (tfaces(nf,8),2);
        pz(1,$+1) = tpoints (tfaces(nf,1),3);
        pz(2,$)   = tpoints (tfaces(nf,6),3);
        pz(3,$)   = tpoints (tfaces(nf,7),3);
        pz(4,$)   = tpoints (tfaces(nf,8),3);
        pcf($+1)  = tfaces(nf,9);  
        nfacess=nfacess+1;

   end;
  end;
 
  // ETAPE/STEP 17 : CREATION DES FICHIERS DATA / CREATING THE DATA FILES
  mfprintf (fmch,"\nETAPE 17/STEP : CREATION DES FICHIERS DATA / CREATING THE DATA FILES\n");
  mfprintf (fmch,"\nFichier/File %sA.DAT\n",racine);
  mfprintf (fmch,"%i\n",npoints);
  mfprintf (fmch,"%i\n",epaisseur);
//  mfprintf (fmch,"%i\n",nsegments+1);
  mfprintf (fmch,"%i\n",nsegments);
  mfprintf (fmch,"%i\n",nfacess);
  [f,erreur] = mopen (racine + "A.DAT","wb");
  mput (npoints);
  mput (epaisseur);
//  mput (nsegments+1);
  mput (nsegments);
  mput (nfacess);
  mclose (f);
  
  mfprintf (fmch,"\nTableau %sS\n",racine);
  for ns=1:nsegs do
    mfprintf (fmch,"%i   %f  %f  %f\n",ns,ts (ns,1),ts (ns,2),ts (ns,3));
  end;
  [f,erreur] = mopen (racine + "S.DAT","wb");
  mput (ts,"f");
  mclose (f);
  
  mfprintf (fmch,"\nTableau %sT\n",racine);
//  for ns=1:nsegments+1 do
  for ns=1:nsegments do
    mfprintf (fmch,"%i   %i\n",ns,tcs (ns));
  end;
  [f,erreur] = mopen (racine + "T.DAT","wb");
  mput (tcs);
  mclose (f);
  
  mfprintf (fmch,"\nTableau %sX\n",racine);
  for nf=1:nfacess do
    mfprintf (fmch,"%i   %f  %f  %f  %f\n",nf,px(1,nf),px(2,nf),px(3,nf),px(4,nf));
  end;
  [f,erreur] = mopen (racine + "X.DAT","wb");
  mput (px,"f");
  mclose (f);
  
  mfprintf (fmch,"\nTableau %sY\n",racine);
  for nf=1:nfacess do
    mfprintf (fmch,"%i   %f  %f  %f  %f\n",nf,py(1,nf),py(2,nf),py(3,nf),py(4,nf));
  end;
  [f,erreur] = mopen (racine + "Y.DAT","wb");
  mput (py,"f");
  mclose (f);
  
  mfprintf (fmch,"\nTableau %sZ\n",racine);
  for nf=1:nfacess do
    mfprintf (fmch,"%i   %f  %f  %f  %f\n",nf,pz(1,nf),pz(2,nf),pz(3,nf),pz(4,nf));
  end;
  [f,erreur] = mopen (racine + "Z.DAT","wb");
  mput (pz,"f");
  mclose (f);
  
  mfprintf (fmch,"\nTableau %sC\n",racine);
  for nf=1:nfacess do
    mfprintf (fmch,"%i   %i\n",nf,pcf (nf));
  end;
  [f,erreur] = mopen (racine + "C.DAT","wb");
  mput (pcf);
  mclose (f);

  // ETAPE/STEP 18 : FERMETURE DES FICHIERS / CLOSING THE FILES
end;
mfprintf (fmch,"\nETAPE/STEP 18 : FERMETURE DES FICHIERS / CLOSING THE FILES\n");
str = mgetl (fs,1);
if str == "FINEND" then 
  mfprintf (fmch,"\nFermeture FINEND reconnue / Closing FINEND is identified\n");
else
  mfprintf (fmch,"FERMETURE FINEND NON RECONNUE / CLOSING FINEND NOT IDENTIFIED\n");
  mfprintf (fmch,str + "\n");
  mclose (fs);  
  mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
  mclose (fmch);  
  mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
  mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
  abort;
end;              

mclose (fs);
mclose (fmch);
mprintf ("\nFin normale d''excution du programme / Correct end of running\n");

