//  PROGRAMME SDISTS
//  Version 4.1.5 20051017
//  Copyright Jacques-Deric Rouault
//  Designed for Scilab 3.1.1

mprintf ("\nPROGRAMME SDISTS : CALCUL DES DISTANCES DES SOMMETS\n");
mprintf ("PROGRAM SDISTS : COMPUTING THE DISTANCES OF VERTICES\n");
racine_prog = "SDISTS";

// ETAPE/STEP 01 : REPERTOIRE DE TRAVAIL / WORKING DIRECTORY
[fsci,erreur] = mopen (racine_prog + ".SCI","r");
repertoire_prog = getcwd ();
if erreur<>0 then
  repertoire_prog=tk_getdir(title="REPERTOIRE DE L''APPLICATION\nAPPLICATION DIRECTORY");
  chdir (repertoire_prog);
  [fsci,erreur] = mopen (racine_prog + ".SCI","r");
  if erreur<>0 then 
    mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine_prog + ".SCI\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine_prog + ".SCI\n\n");
    abort; 
  end;  
end;
mclose (fsci);

// ETAPE/STEP 02 : OUVERTURE DU FICHIER SOLIDES.TXT / OPENING THE FILE SOLIDES.TXT
mprintf ("Lecture du fichier / Reading the file SOLIDES.TXT\n");
[fs,err] = mopen ("SOLIDES.TXT","r");
if err<>0 then
  mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER SOLIDES.TXT\n");
  mprintf ("\nTHE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE SOLIDES.TXT\n");
  abort; 
end;
str = mgetl (fs,1);
if str == "SOLIDS-V4" then 
else
  mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
  mclose (fs);  
  abort;
end;              
str = mgetl (fs,1);

// ETAPE/STEP 03 : LECTURE DES RACINES READING THE ROOTS
[fmch,err] = mopen ("SDISTS.MCH","w");
mfprintf (fmch,"PROGRAMME SDISTS : CALCUL DES DISTANCES DES SOMMETS\n");
mfprintf (fmch,"PROGRAM SDISTS : COMPUTING THE DISTANCES OF VERTICES\n");
mfprintf (fmch,"Version 4.1.5 20051017\n");
mfprintf (fmch,"Copyright Jacques-Deric Rouault\n");
str = mgetl (fs,1);
nracines = sscanf (str,"%i");
for nr=1:nracines do
  str = mgetl (fs,1);
  [rang,rep,racine] = sscanf (str,"%i %i %s");
  mprintf ("\nAnalyse du fichier / Analysing the file " + racine + ".TXT\n");
  mfprintf (fmch,"\nAnalyse du fichier / Analysing the file " + racine + ".TXT\n");
  
  // ETAPE/STEP 04 : OUVERTURE DU FICHIER RACINE
  [fr,err] = mopen (racine + ".TXT","r");
  if err<>0 then
    mprintf ("LE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine + ".TXT\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine + ".TXT\n");
    mclose (fs);
    abort; 
  end;
  str = mgetl (fr,1);
  if str == "SOLIDE-V4" then 
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fmch,"%s\n",str);

  // ETAPE 05/STEP : LECTURE DE LA SECTION POINTS / READING THE SECTION POINTS
  str = mgetl (fr,1);
  if str == "POINTS" then 
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fmch,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fmch);
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  npoints = sscanf (str,"%i");
  mfprintf (fmch,"%s\n",str);
  px = [];
  py = [];
  pz = [];
  for np=1:npoints do
    str = mgetl (fr,1);
    [rang,x,y,z] = sscanf (str,"%i %f %f %f");
    px (np) = x;
    py (np) = y;
    pz (np) = z;
    mfprintf (fmch,"%i  %f  %f  %f\n",np, px(np),py(np),pz(np));   
  end;
  
  pd = [];
  nd=0;
  mfprintf (fmch,"\nDistances de points / Distances between points\n");
  for np1=1:npoints-1 do
    for np2=np1+1:npoints do
      nd = nd+1;
      pd(nd,1) = np1;
      pd(nd,2) = np2;
      d = (px(np1)-px(np2))**2+(py(np1)-py(np2))**2+(pz(np1)-pz(np2))**2;
      pd(nd,3) = sqrt (d);
      mfprintf (fmch,"P1 = %3i  -  P2 = %3i  - D = %f\n",pd(nd,1),pd(nd,2),pd(nd,3));
    end;
  end;  

  [v,k]= sort (pd(:,3),'r');
  pdt = [];
  for n=1:nd do
    pdt(n,1) = pd(k(nd-n+1),1);
    pdt(n,2) = pd(k(nd-n+1),2);
    pdt(n,3) = pd(k(nd-n+1),3);
  end;
  
  mfprintf (fmch,"\nDistances trie de points / Sorted distances between points\n");
  for n=1:nd do
    mfprintf (fmch,"P1 = %3i  -  P2 = %3i  - D = %f\n",pdt(n,1),pdt(n,2),pdt(n,3));
  end;
   
  mprintf ("Fichier " + racine + ".TXT correctement analys\n");
  mprintf ("File " + racine + ".TXT correctly analysed\n");
  mfprintf (fmch,"Fichier " + racine + ".TXT correctement analys\n");
  mfprintf (fmch,"File " + racine + ".TXT correctly analysed\n");
  mclose (fr);

  // ETAPE/STEP 11 : FERMETURE DES FICHIERS / CLOSING FILES
end;           

mclose (fmch);
mclose (fs);
mprintf ("\nFin normale d''excution du programme / Correct end of running\n");
