//  PROGRAMME SMANUEL =  REPRESENTATION DES POLYEDRES DANS UNE FENETRE UNIQUE
//  PROGRAM SMANUEL =  REPRESENTATION POLYHEDRONS IN A SINGLE WINDOW
//  Version 4.1.1 20051011
//  Copyright Jacques-Deric Rouault
//  Designed for Scilab 3.1.1

mprintf ("\nPROGRAMME SMANUEL : REPRESENTATION DES POLYEDRES DANS UNE FENETRE UNIQUE\n");
mprintf ("PROGRAM SMANUEL =  REPRESENTATION POLYHEDRONS IN A SINGLE WINDOW\n");
racine_prog = "SMANUEL";

// ETAPE/STEP 01 : REPERTOIRE DE TRAVAIL / WORKING DIRECTORY
[fsci,erreur] = mopen (racine_prog + ".SCI","r");
repertoire_prog = getcwd ();
if erreur<>0 then
  repertoire_prog=tk_getdir(title="REPERTOIRE DE L''APPLICATION\nAPPLICATION DIRECTORY");
  chdir (repertoire_prog);
  [fsci,erreur] = mopen (racine_prog + ".SCI","r");
  if erreur<>0 then 
    mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine_prog + ".SCI\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine_prog + ".SCI\n\n");
    abort; 
  end;  
end;
mclose (fsci);

// ETAPE/STEP 02 : CREATION DE LA FENETRE GRAPHIQUE / CEATING THE GRAPHIC WINDOW
hf = scf (1);
hf.color_map = jetcolormap (100);
ha = hf.children;
ha.axes_visible = "on";
ha.isoview = "on";
ha.view = "3d";
ha.data_bounds = [-1,-1,-1; 1,1,1];
ha.x_label.text = "x";
ha.x_label.font_size = 5;
ha.y_label.text = "y";
ha.y_label.font_size = 5;
ha.z_label.text = "z";
ha.z_label.font_size = 5;

// ETAPE/STEP 03 : OUVERTURE DU FICHIER SOLIDES.TXT / OPENING THE FILE SOLIDES.TXT
mprintf ("Lecture du fichier / Reading the file SOLIDES.TXT\n");
[fs,err] = mopen ("SOLIDES.TXT","r");
if err<>0 then
  mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER SOLIDES.TXT\n");
  mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE SOLIDES.TXT\n");
  abort; 
end;
str = mgetl (fs,1);
if str == "SOLIDS-V4" then 
else
  mclose (fs);  
  mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
  mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
  abort;
end;              
comment = mgetl (fs,1);
hf.figure_name = comment;

// ETAPE 04 : LECTURE DES RACINES
str = mgetl (fs,1);
nracines = sscanf (str,"%i");
for nr=1:nracines do
  str = mgetl (fs,1);
  [rang,rep,racine] = sscanf (str,"%i %i %s");
  select rep
    case 0 then ;
    case 1 then ;
    case 2 then ;
    else
      mclose (fs);  
      mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
      mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
      abort;     
  end;
 
  // ETAPE/STEP 05 : LECTURE DES RACINES / READING ROOTS
  [f,erreur] = mopen (racine + "A.DAT","rb");
  npoints   = mget (1,"i",f);
  epaisseur = mget (1,"i",f);
  nsegments = mget (1,"i",f);
  nfaces    = mget (1,"i",f);
  mclose (f);
  
  select rep
    case 0 then ; // non reprsent
    case 1 then   // reprsent en segments 
      [f,erreur] = mopen (racine + "S.DAT","rb");
      ts = mget (nsegments*6,"f",f);
      mclose (f);
      ts = matrix (ts,2*nsegments,3);         
      [f,erreur] = mopen (racine + "T.DAT","rb");
      pc = mget (nsegments,"i",f);
      mclose (f);
      input ("S1");
      xsegs ([0, 1], [0, 1]);
      input ("S2");
      hs = gce ();
      hs.data = ts;   
      hs.segs_color = pc;
      hs.thickness = epaisseur;
      if nr==1 then
        xmin = min(ts(:,1));
        xmax = max(ts(:,1));
        ymin = min(ts(:,2));
        ymax = max(ts(:,2));
        zmin = min(ts(:,3));
        zmax = max(ts(:,3));
      else
        xxmin = min(ts(:,1));
        xxmax = max(ts(:,1));
        yymin = min(ts(:,2));
        yymax = max(ts(:,2));
        zzmin = min(ts(:,3));
        zzmax = max(ts(:,3));
        xmin  = min(xmin,xxmin);
        xmax  = max(xmax,xxmax);
        ymin  = min(ymin,yymin);
        ymax  = max(ymax,yymax);
        zmin  = min(zmin,zzmin);
        zmax  = max(zmax,zzmax);
      end;
      ha.data_bounds = [xmin,ymin,zmin; xmax,ymax,zmax];
      ha.rotation_angles = [45, 215];
    case 2 then   // reprsent en facettes
      [f,erreur] = mopen (racine + "X.DAT","rb");
      px = mget (nfaces*4,"f",f);
      mclose (f);
      [f,erreur] = mopen (racine + "Y.DAT","rb");
      py = mget (nfaces*4,"f",f);
      mclose (f);
      [f,erreur] = mopen (racine + "Z.DAT","rb");
      pz = mget (nfaces*4,"f",f);
      mclose (f);
      [f,erreur] = mopen (racine + "C.DAT","rb");
      pc = mget (nfaces,"i",f);
      mclose (f);
      px = matrix (px,4,nfaces);
      py = matrix (py,4,nfaces);
      pz = matrix (pz,4,nfaces);
      input ("F1");
      plot3d (px, py, list (pz,pc));
      input ("F2");
      hp = gce ();
      hp.color_mode=-1;
      if nr==1 then
        xmin = min(px);
        xmax = max(px);
        ymin = min(py);
        ymax = max(py);
        zmin = min(pz);
        zmax = max(pz);
      else
        xxmin = min(px);
        xxmax = max(px);
        yymin = min(py);
        yymax = max(py);
        zzmin = min(pz);
        zzmax = max(pz);
        xmin  = min(xmin,xxmin);
        xmax  = max(xmax,xxmax);
        ymin  = min(ymin,yymin);
        ymax  = max(ymax,yymax);
        zmin  = min(zmin,zzmin);
        zmax  = max(zmax,zzmax);
      end;
      ha.data_bounds = [xmin,ymin,zmin; xmax,ymax,zmax];
      ha.rotation_angles = [45, 215];
  end;
  input ("B");
  // ETAPE/STEP 06 : FERMETURE DES FICHIERS / CLOSING FILES
end;
str = mgetl (fs,1);
if str == "FINEND" then 
else
  mclose (fs);  
  mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
  mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
  abort;
end;              

mclose (fs);
mprintf ("\nFin normale d''excution du programme / Correct end of running\n");
