//  PROGRAMME SUNIT
//  Version 4.1.2 20051010
//  Copyright Jacques-Deric Rouault
//  Designed for Scilab 3.1.1

mprintf ("\nPROGRAMME SUNIT : MISE DES POINTS A LA DISTANCE UNITE\n");
mprintf ("PROGRAM SUNIT : PUTTING THE POINTS AT THE UNIT DISTANCE\n");
racine_prog = "SUNIT";

// ETAPE/STEP 01 : REPERTOIRE DE TRAVAIL / WORKING DIRECTORY
[fsci,erreur] = mopen (racine_prog + ".SCI","r");
repertoire_prog = getcwd ();
if erreur<>0 then
  repertoire_prog=tk_getdir(title="REPERTOIRE DE L''APPLICATION\nAPPLICATION DIRECTORY");
  chdir (repertoire_prog);
  [fsci,erreur] = mopen (racine_prog + ".SCI","r");
  if erreur<>0 then 
    mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine_prog + ".SCI\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine_prog + ".SCI\n\n");
    abort; 
  end;  
end;
mclose (fsci);

// ETAPE/STEP 02 : OUVERTURE DU FICHIER SOLIDES.TXT / OPENING THE FILE SOLIDES.TXT
mprintf ("Lecture du fichier / Reading the file SOLIDES.TXT\n");
[fs,err] = mopen ("SOLIDES.TXT","r");
if err<>0 then
  mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER SOLIDES.TXT\n");
  mprintf ("\nTHE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE SOLIDES.TXT\n");
  abort; 
end;
str = mgetl (fs,1);
if str == "SOLIDS-V4" then 
else
  mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
  mclose (fs);  
  abort;
end;              
str = mgetl (fs,1);

// ETAPE/STEP 03 : LECTURE DES RACINES READING THE ROOTS
str = mgetl (fs,1);
nracines = sscanf (str,"%i");
for nr=1:nracines do
  str = mgetl (fs,1);
  [rang,rep,racine] = sscanf (str,"%i %i %s");
  mprintf ("\nAnalyse du fichier / Analysing the file " + racine + ".TXT\n");
  
  // ETAPE/STEP 04 : OUVERTURE DU FICHIER RACINE
  [fr,err] = mopen (racine + ".TXT","r");
  if err<>0 then
    mprintf ("LE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine + ".TXT\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine + ".TXT\n");
    mclose (fs);
    abort; 
  end;
  str = mgetl (fr,1);
  if str == "SOLIDE-V4" then 
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mclose (fs);  
    abort;
  end;   
  [fu,err] = mopen (racine + "U.TXT","w");
  mfprintf (fu,"%s\n",str);
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);

  // ETAPE 05/STEP : LECTURE DE LA SECTION POINTS / READING THE SECTION POINTS
  str = mgetl (fr,1);
  if str == "POINTS" then 
    mfprintf (fu,"%s\n",str);
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fu,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fu);
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  npoints = sscanf (str,"%i");
  mfprintf (fu,"%s\n",str);
  for np=1:npoints do
    str = mgetl (fr,1);
    [rang,x,y,z] = sscanf (str,"%i %f %f %f");
    long2 = x*x+y*y+z*z;
    if long2>0.0 then
      long = sqrt (long2);
      x = x/long;
      y = y/long;
      z = z/long;
      mfprintf (fu,"%i  %f  %f  %f\n",np, x,y,z);   
    else
      mprintf ("PROBLEME DE NORME - NORM ERROR\n");
      mclose (fr);  
      mfprintf (fu,"PROBLEME DE NORME - NORM ERROR\n");
      mclose (fu);
      mclose (fs);  
      abort;
    end;
  end;
   
  // ETAPE/STEP 06 : LECTURE DE LA SECTION SEGMENTS / READING THE SECTION SEGMENTS
  str = mgetl (fr,1);
  if str == "SEGMENTS" then 
    mfprintf (fu,"%s\n",str);
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fu,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fu);
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  epaisseur = sscanf (str,"%i");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  nsegments = sscanf (str,"%i");
  tsegments = [];
  for ns=1:nsegments do
    str = mgetl (fr,1);
    mfprintf (fu,"%s\n",str);
  end;
   
  // ETAPE/STEP 07 : LECTURE DE LA SECTION FACES / READING THE SECTION FACES
  str = mgetl (fr,1);
  if str == "FACES" then 
    mfprintf (fu,"%s\n",str);
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fu,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fu);
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  nfaces = sscanf (str,"%i");
  
  for nf=1:nfaces do
    str = mgetl (fr,1);
    mfprintf (fu,"%s\n",str);
  end;
   
  // ETAPE/STEP 08 : LECTURE DE LA SECTION TRANSFORMATIONS / READING THE SECTION TRANSFORMATIONS
  str = mgetl (fr,1);
  if str == "TRANSFS" then 
    mfprintf (fu,"%s\n",str);
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fu,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fu);
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  homox = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  homoy = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  homoz = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  azimut = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  tangue = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  roule = sscanf (str,"%f");
  
  // ETAPE/STEP 09 : LECTURE DE LA SECTION IMPLEMENTATION / READING THE SECTION IMPLEMENTATION
  str = mgetl (fr,1);
  if str == "IMPLEM" then 
    mfprintf (fu,"%s\n",str);
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fu,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fu);
    mclose (fs);  
    abort;
  end;   
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  transx = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  transy = sscanf (str,"%f");
  str = mgetl (fr,1);
  mfprintf (fu,"%s\n",str);
  transz = sscanf (str,"%f");

  // ETAPE/STEP 10 : LECTURE DE LA SECTION FINEND / READING THE SECTION FINEND
  str = mgetl (fr,1);
  if str == "FINEND" then 
    mfprintf (fu,"%s\n",str);
    mprintf ("Fichier " + racine + ".TXT correctement analys\n");
    mprintf ("File " + racine + ".TXT correctly analysed\n");
    mclose (fr);
    mclose (fu);
  else
    mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fr);  
    mfprintf (fu,"PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
    mclose (fu);
    mclose (fs);  
    abort;
  end;

  // ETAPE/STEP 11 : FERMETURE DES FICHIERS / CLOSING FILES
end;
str = mgetl (fs,1);
if str == "FINEND" then 
else
  mprintf ("PROBLEME DE SYNTAXE - SYNTAX ERROR\n");
  mclose (fs);  
  abort;
end;              

mclose (fs);
mprintf ("\nFin normale d''excution du programme / Correct end of running\n");
