//  PROGRAMME SWINDOWS =  REPRESENTATION DES POLYEDRES DANS DES FENETRES DIFFERENTES
//  PROGRAM SWINDOWS =  REPRESENTATION POLYHEDRONS IN SEPARATE WINDOWS
//  Version 4.1.1 20051011
//  Copyright Jacques-Deric Rouault
//  Designed for Scilab 3.1.1

mprintf ("\nPROGRAMME SWINDOWS : REPRESENTATION DES POLYEDRES DANS DES FENETRES DIFFERENTES\n");
mprintf ("PROGRAM SWINDOWS =  REPRESENTATION POLYHEDRONS IN SEPARATE WINDOWS\n");
racine_prog = "SWINDOWS";

// ETAPE/STEP 01 : REPERTOIRE DE TRAVAIL / WORKING DIRECTORY
[fsci,erreur] = mopen (racine_prog + ".SCI","r");
repertoire_prog = getcwd ();
if erreur<>0 then
  repertoire_prog=tk_getdir(title="REPERTOIRE DE L''APPLICATION\nAPPLICATION DIRECTORY");
  chdir (repertoire_prog);
  [fsci,erreur] = mopen (racine_prog + ".SCI","r");
  if erreur<>0 then 
    mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine_prog + ".SCI\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine_prog + ".SCI\n\n");
    abort; 
  end;  
end;
mclose (fsci);

// ETAPE/STEP 02 : OUVERTURE DU FICHIER SOLIDES.TXT / OPENING THE FILE SOLIDES.TXT
mprintf ("Lecture du fichier / Reading the file SOLIDES.TXT\n");
[fs,err] = mopen ("SOLIDES.TXT","r");
if err<>0 then
  mprintf ("\nLE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER SOLIDES.TXT\n");
  mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE SOLIDES.TXT\n");
  abort; 
end;
str = mgetl (fs,1);
if str == "SOLIDS-V4" then 
else
  mclose (fs);  
  mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
  mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
  abort;
end;              
str = mgetl (fs,1);

// ETAPE/STEP 03 : LECTURE DES RACINES / READING ROOTS
str = mgetl (fs,1);
nracines = sscanf (str,"%i");
for nr=1:nracines do
  str = mgetl (fs,1);
  [rang,rep,racine] = sscanf (str,"%i %i %s");
  select rep
    case 0 then ;
    case 1 then ;
    case 2 then ;
    else
      mclose (fs);  
      mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
      mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
      abort;     
  end;
  
  // ETAPE/STEP 04 : OUVERTURE DU FICHIER RACINE / OPENING THE ROOT FILE
  [fr,err] = mopen (racine + ".TXT","r");
  if err<>0 then
    mprintf ("LE REPERTOIRE COURANT NE CONTIENT PAS LE FICHIER " + racine + ".TXT\n");
    mprintf ("THE CURRENT DIRECTORY DOES NOT CONTAIN THE FILE " + racine + ".TXT\n");
    mclose (fs);
    abort; 
  end;
  str = mgetl (fr,1);
  if str == "SOLIDE-V4" then 
  else
    mclose (fr);  
    mclose (fs);  
    mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
    mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
    abort;
  end;   
  comment = mgetl (fr,1);
  mclose (fr);

  // ETAPE/STEP 05 : CREATION DE LA FENETRE / CREATING THE WINDOW
  hf = scf (nr);
  hf.figure_name = comment;
  hf.color_map = jetcolormap (100);
  ha = hf.children;
  ha.axes_visible = "on";
  ha.isoview = "on";
  ha.view = "3d";
  ha.data_bounds = [-1,-1,-1; 1,1,1];
  ha.x_label.text = "x";
  ha.x_label.font_size = 5;
  ha.y_label.text = "y";
  ha.y_label.font_size = 5;
  ha.z_label.text = "z";
  ha.z_label.font_size = 5;

  // ETAPE/STEP 06 : LECTURE DES FICHIERS DATA / READING THE DATA FILES
  [f,erreur] = mopen (racine + "A.DAT","rb");
  npoints   = mget (1,"i",f);
  epaisseur = mget (1,"i",f);
  nsegments = mget (1,"i",f);
  nfaces    = mget (1,"i",f);
  mclose (f);
  
  select rep
    case 0 then ; // non reprsent
    case 1 then   // reprsent en segments 
      [f,erreur] = mopen (racine + "S.DAT","rb");
      ts = mget (nsegments*6,"f",f);
      mclose (f);
      ts = matrix (ts,2*nsegments,3);         
      [f,erreur] = mopen (racine + "T.DAT","rb");
      pc = mget (nsegments,"i",f);
      mclose (f);
      xsegs ([0, 1], [0, 1]);
      hs = gce ();
      hs.data = ts;   
      hs.segs_color = pc;
      hs.thickness = epaisseur;
      xmin = min(ts(:,1));
      xmax = max(ts(:,1));
      ymin = min(ts(:,2));
      ymax = max(ts(:,2));
      zmin = min(ts(:,3));
      zmax = max(ts(:,3));
      ha.data_bounds = [xmin,ymin,zmin; xmax,ymax,zmax];
      ha.rotation_angles = [45, 215];
    case 2 then   // reprsent en facettes
      [f,erreur] = mopen (racine + "X.DAT","rb");
      px = mget (nfaces*4,"f",f);
      mclose (f);
      [f,erreur] = mopen (racine + "Y.DAT","rb");
      py = mget (nfaces*4,"f",f);
      mclose (f);
      [f,erreur] = mopen (racine + "Z.DAT","rb");
      pz = mget (nfaces*4,"f",f);
      mclose (f);
      [f,erreur] = mopen (racine + "C.DAT","rb");
      pc = mget (nfaces,"i",f);
      mclose (f);
      px = matrix (px,4,nfaces);
      py = matrix (py,4,nfaces);
      pz = matrix (pz,4,nfaces);
      plot3d (px, py, list (pz,pc));
      hp = gce ();
      hp.color_mode=-1;
      xmin = min(px);
      xmax = max(px);
      ymin = min(py);
      ymax = max(py);
      zmin = min(pz);
      zmax = max(pz);
      ha.data_bounds = [xmin,ymin,zmin; xmax,ymax,zmax];
      ha.rotation_angles = [45, 215];
  end;

  // ETAPE/STEP 07 : FERMETURE DES FICHIERS / CLOSING FILES
end;
str = mgetl (fs,1);
if str == "FINEND" then 
else
  mclose (fs);  
  mprintf ("PROBLEME DE SYNTAXE : VOIR LE FICHIER MOUCHARD SOLIDES.MCH\n");
  mprintf ("SYNTAX ERROR: SEE THE SNEAK FILE SOLIDES.MCH\n");
  abort;
end;              

mclose (fs);
mprintf ("\nFin normale d''excution du programme / Correct end of running\n");
